#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef unsigned long _u32;

static inline _u32 endianswap(_u32 x)
{

   return (x>>24) | ((x&0x00FF0000L)>>8) | ((x&0x0000FF00L)<<8) | (x<<24);

}

static inline _u32 getword(FILE *in)
{
    _u32 x;
    fread(&x, 4, 1, in);
    return endianswap(x);

}


void main(void)
{
   FILE *in, *out;
   _u32 ORG, LEN, FLAGS, RSA;
   char name[32];
   char Lit;

   in=fopen("misc_c", "rb");

   printf("FLAGS:    %08lx\n", FLAGS=getword(in));
   printf("RSA sign: %08lx\n\n", RSA=getword(in));
   if(FLAGS!=0x40000) exit(1);

   for(Lit='A'; ; Lit++)
     {
       ORG=getword(in);
       LEN=getword(in);
       if(LEN==0) break;
       fseek(in,  0xC0, SEEK_CUR);
       fread(&name, 32, 1, in);
       fseek(in, -0xE0, SEEK_CUR);

       if(name[0]==0)
         {
            strcpy(name, "Block #?");
            name[strlen("Block #?")-1]=Lit;
         }

       printf("%c. Length =0x%lx ORG=0x%lx Name of block: \"%s\"\n", Lit, LEN, ORG, name);

       {
       char buf[2048];

         out=fopen(name, "wb");
         while(LEN>=sizeof(buf))
         {
           fread(&buf, sizeof(buf), 1, in);
           fwrite(&buf, sizeof(buf), 1, out);
           LEN -= sizeof(buf);
         }
         while(LEN--) fputc(fgetc(in), out);
         fclose(out);
       }
//       fseek(in, LEN, SEEK_CUR);

     }
     {
       char sign[64]; // RSA sign
         out=fopen("sign", "wb");
         fseek(in,  RSA, SEEK_SET);
         fread(&sign, 64, 1, in);
         fwrite(&sign, 64, 1, out);
         fclose(out);
     }

     fclose(in);

   


}